/*
 *  Released under the GNU LGPL.  See http://www.gnu.org/licenses/lgpl.txt
 *
 *  This program is part of the DeSmet C Compiler
 *
 *  This library is free software * you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published
 *  by the Free Software Foundatation * either version 2.1 of the License, or
 *  any later version.
 *
 *  This library is distributed in the hope that it will be useful, but
 *  WITHOUT ANY WARRANTY * without even the implied warranty of MERCHANTABILITY
 *  or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU Lesser General Public
 *  License for more details.
 */
/*	DCOPY.C	-	copy 320K pc floppy. formats and copies	*/



int	tracks=40,sides=2,sectors=8;

char tempname[]="c:dcopy.tmp";
char buffer[9*512];
int  outfile=-1;
char voption,cmd;

main(argc,argv)
	int argc;
	char *argv[]; {

	puts("DCOPY V1.0         C-Ware Manufacturing Control System\n\n");
	puts("Copies single or double sided 8 ot 9 track MS-DOS diskettes and\n");
	puts("single or double sided CP/M diskettes.\n\n");
	puts("     invocation:  A>DCOPY [E[:]] [/V]\n");
	puts("                  The argument is the drive to use to save a copy of the disk\n");
	puts("                  to be copied. Default is C:. The /V option causes\n");
	puts("                  verification of the new disk.\n\n");

	if (argc > 3) ferror("too many arguments","");
	if (argc >= 2) {
		if (*argv[1] != '\\') tempname[0]=*argv[1];
		else voption= toupper(*++argv[1]) == 'V';
		}
	if (argc == 3 && *argv[2] == '/')
		voption= toupper(*++argv[2]) == 'V';

	get_master();

	puts("\nCaution: all disks stuck in drive A: will be clobbered!!!\n");

	while (1) {
		puts("\nput disk in drive A: and hit   Q for quit   space for next");
		if (voption == 0) puts("   V for verify");
		if ((cmd=toupper(getchar())) == 'Q') {
			close(outfile);
			if (unlink(tempname) == -1) error("cannot delete",tempname);
			puts("\nbye");
			exit();
			}
		putchar('\n');
		if (cmd == ' ') copy_disk();
		if (cmd == 'V') checkit();
		}
	}



/*	read in the source disk	*/

int  read_disk(),write_disk(),read_temp(),write_temp(),verify();

get_master() {

	if ((outfile=creat(tempname)) == -1) ferror("cannot create",tempname);
	puts("place disk to be copied into drive A: and hit any key");
	getchar();
	putchar('\n');

	/* read second sector to get type	*/
	if (reads(buffer,0,0,0,2,1) == -1) ferror("cannot read disk","");
	if (buffer[0] == 0xfc) {
		puts("copying a single sided 9 track MS-DOS diskette\n");
		sides=1;
		sectors=9;
		}
	else if (buffer[0] == 0xfd) {
		puts("copying a double sided 9 track MS-DOS diskette\n");
		sectors=9;
		}
	else if (buffer[0] == 0xfe) {
		puts("copying a single sided 8 track MS-DOS diskette\n");
		sides=1;
		}
	else if (buffer[0] == 0xff) {
		puts("copying a double sided 8 track MS-DOS diskette\n");
		}
	else {		/*	better be CP/M	*/
		/* read first sector to get type	*/

		if (reads(buffer,0,0,0,1,1) == -1) ferror("cannot read disk","");
		if (buffer[511] == 0) {
			puts("copying a single sided 8 track CP/M-86 diskette\n");
			sides=1;
			}
		else if (buffer[511] == 1) {
			puts("copying a double sided 8 track CP/M-86 diskette\n");
			}
		else ferror("not a recognised diskette","");
		}

	if (do_a_disk(read_disk,write_temp) == -1)
		ferror("cannot read source disk","");
	}


copy_disk() {

	if (rewind(outfile) == -1) ferror("cannot rewind",tempname);
	if (do_a_disk(read_temp,write_disk) == -1) {
		error("cannot write destination disk","");
		return;
		}
	if (voption) checkit();
	}


checkit() {

	if (rewind(outfile) == -1) ferror("cannot rewind",tempname);
	if (do_a_disk(read_disk,verify) == -1)
		error("output disk cannot be verified","");
	}



/*	do something for the entire disk	*/

do_a_disk(proca,procb)
	int (*proca)(),(*procb)(); {
	int i;

	for (i=0; i < tracks*sides*sectors; i+=sectors) {
		if ((*proca)(i) == -1) return -1;
		if ((*procb)(i) == -1) return -1;
		}
	}

read_disk(reltrk)
	unsigned reltrk; {
	int cyl,head;

	cyl=reltrk/sectors;
	head=0;
	if (sides == 2) {
		head=cyl&1;
		cyl>>=1;
		}
	return reads(buffer,0,head,cyl,1,sectors);	
	}


write_disk(reltrk)
	unsigned reltrk; {
	int  cyl,head,i;
	char chrn[9][4];

	cyl=reltrk/sectors;
	head=0;
	if (sides == 2) {
		head=cyl&1;
		cyl>>=1;
		}
	for (i=1; i <= sectors; i++) {
		chrn[i-1][0]=cyl;
		chrn[i-1][1]=head;
		chrn[i-1][2]=i;
		chrn[i-1][3]=2;
		}
		
	if (format(chrn,0,head,cyl,1,sectors) == -1) return -1;
	return writes(buffer,0,head,cyl,1,sectors);	
	}

read_temp(reltrk)
	int  reltrk; {

	return read(outfile,buffer,sectors*512);
	}

write_temp(reltrk)
	int  reltrk; {

	if (write(outfile,buffer,sectors*512) == -1)
		ferror("cannot write",tempname);
	}

verify(reltrk)
	unsigned reltrk; {
	char buffer2[512*9];
	unsigned num;
	unsigned *fromptr,*toptr,*endptr;

	num=sectors*512;
	if (read(outfile,buffer2,num) == -1)
		ferror("cannot read",tempname);
	if (compare(buffer,buffer2,num) == 0) {
		error("verify error","");
		return -1;
		}
	return 0;
	}





ferror(stra,strb)
	char *stra,*strb; {

	puts("DCOPY aborted: ");
	puts(stra);
	putchar(' ');
	puts(strb);
	if (outfile != -1) {
		close(outfile);
		if (unlink(tempname) == -1) error("cannot delete",tempname);
		}
	exit(0);
	}

error(stra,strb)
	char *stra,*strb; {

	puts("error: ");
	puts(stra);
	putchar(' ');
	puts(strb);
	putchar('\n');
	}
