/*
 *  Released under the GNU LGPL.  See http://www.gnu.org/licenses/lgpl.txt
 *
 *  This program is part of the DeSmet C Compiler
 *
 *  This library is free software * you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published
 *  by the Free Software Foundatation * either version 2.1 of the License, or
 *  any later version.
 *
 *  This library is distributed in the hope that it will be useful, but
 *  WITHOUT ANY WARRANTY * without even the implied warranty of MERCHANTABILITY
 *  or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU Lesser General Public
 *  License for more details.
 */
/*	TESTMD --  test mkdir etc.	*/

#include <c:dos.h>
char curdir[65]="\\";
char buf[80],buf2[80];
char *ptr,*ftell(),*freopen();
long labs();

main() {
	int i;
	char *p;

	if (mkdir("JUNK") == -1) puts("failure 1\n");
	if (getdir(0,&curdir[1]) == -1) puts("failure 2\n");
	if (chdir("JUNK") == -1) puts("failure 3\n");
	if (chdir("..") == -1) puts("failure 4\n");
	if (chdir(curdir) == -1) puts("failure 4\n");
	if (rmdir("JUNK") == -1) puts("failure 5\n");

	if ((i=creat("xx")) == -1) puts("failure 6\n");
	close (i);
	if (chmod("xx",CHDIR_READONLY) == -1) puts("failure 7\n");
	if ((i=open("xx",2)) != -1) puts("failure 8\n");
	if (chmod("xx",0) == -1) puts("failure 10\n");
	if (unlink("xx")== -1) puts("failure 11\n");

	if (closeall()== -1) puts("failure 12\n");

	if ((i=creat("xx")) == -1) puts("failure 13\n");
	if (dup(i) == -1) puts("failure 14\n");
	close (i);

	if ((i=dup2(1,9)) == -1) puts("failure 15\n");
	if (write(9,"is ok ",6) == -1) puts("failure 16\n");
	if (close(9)== -1) puts("failure 16.1\n");

	if ((i=creat("xx")) == -1) puts("failure 17\n");
	if (write(i,"hello",5) != 5) puts("failure 18\n");
	if (ftell(i) != 5) puts("failure 18.1\n");
	rewind(i);
	if (filelength(i) != 5) puts("failure 19\n");
	if (ftell(i) != 0) puts("failure 19.1\n");
	close (i);

	if (findfile("INCLUDE","XX",buf) == 0) puts("failure 20\n");

	ptr=1;
	if (fileno(ptr) != 1) puts("failure 21\n");

#ifdef LARGE_CASE
	p=&ptr;
	if (FP_SEG(p) != _showds() || FP_OFF(p) != ((unsigned) &ptr))
		puts("failure 22\n");
#endif

	if ((p=freopen("CON","w",1)) == 0) puts("failure 23\n");
	if (fwrite(" still ok ",10,1,p) == 0) puts("failure 24\n");

	if (unlink("xx") == -1) puts("failure 25\n");

	if (getenv("PATH",buf,80) == -1) puts("failure 26\n");
	if (putenv("PATH",buf) == -1) puts("failure 27\n");
	if (getenv("PATH",buf2,80) == -1) puts("failure 28\n");
	if (strcmp(buf,buf2)) puts("failure 29\n");

	if (isatty(0) != 1) puts("failure 30\n");
	if (labs(-1l) != 1)puts("failure 31\n");

	i=creat("xx");
	write(i,buf,80);
	if (close(i) == -1) puts("failure 31.5\n");
	i=open("xx",2);
	if (i == -1) puts("failure 31.6\n");
/*
	if (locking(i,LOCK,4) != 0) puts("failure 32\n");
	if (locking(i,UNLCK,4) != 0) puts("failure 32.1\n");
*/
	if (unlink("xx") == -1) puts("failure 34\n");

	if (strcmpi("AbC","aBc") != 0) puts("failure 35\n");
    if (strcspn("HELLO THERE","AEIOU") != 7) puts("failure 36\n");
	if (strcmp(strlwr("AbC"),"abc") != 0) puts("failure 37\n");
	if (strcmp(strpbrk("HELLO WORLD","AEIOU"),"ELLO WORLD") != 0)
		puts("failure 38\n");
	if (strcmp(strrev("AbC"),"CbA") != 0) puts("failure 39\n");
	if (strcmp(strset("AbC",'X'),"XXX") != 0) puts("failure 40\n");
	if (strspn("HELLO WORLD","HELP") != 4) puts("failure 41\n");
	if (strcmp(strtok("   , aaa , bbb"," ,\t"),"aaa") != 0)
		puts("failure 42\n");
	if (strcmp(strtok((char *)0," ,\t"),"bbb") != 0)
		puts("failure 43\n");
	if (strcmp(strtok((char *)0," ,\t"),(char *)0) != 0)
		puts("failure 44\n");
	if (strcmp(strupr("AbC"),"ABC") != 0) puts("failure 45\n");
 	puts("bye");
	}
